'use strict';const jsyaml=require('js-yaml');class BundleImporter{constructor(a){this.modelAPI=a.modelAPI,this._getBundleChanges=a.getBundleChanges,this.db=a.db,this.charmstore=a.charmstore,this.hideDragOverNotification=a.hideDragOverNotification,this._dryRunIndex=-1,this._collectedServices=[],this.makeEntityModel=a.makeEntityModel,this.recordSet=null}importBundleYAML(a,b){this.db.notifications.add({title:'Fetching bundle data',message:'Fetching detailed bundle data, this may take some time',level:'important'}),this.fetchDryRun(a,b,null)}importBundleFile(a){const b=this._generateFileReader();return b.onload=this._fileReaderOnload.bind(this,a),b.readAsText(a),this.hideDragOverNotification(),b}importBundleDryRun(a){this.recordSet=this._sortDryRunRecords(a),this._executeDryRun(this.recordSet)}_ensureV4Format(a){try{const b=jsyaml.safeLoad(a);if(b.services&&!b.services.services||b.applications)return a;const c=Object.keys(b)[0],d=b[c];return JSON.stringify(d)}catch(b){return a}}fetchDryRun(a,b,c){a&&(a=this._ensureV4Format(a)),this._getBundleChanges(a,c,this._handleFetchDryRun.bind(this,b))}_handleFetchDryRun(a,b,c){return b&&b.length?void this.db.notifications.add({title:'Error generating changeSet',message:'The following errors occurred while retrieving bundle changes: '+b.join(', '),level:'error'}):void(c=this._addBundleURLAnnotation(a,c),this.importBundleDryRun(c))}_addBundleURLAnnotation(a,b){return b.forEach((c)=>{if('deploy'===c.method){const d=b.length,e=b.some((b)=>{if('setAnnotations'===b.method&&`$${c.id}`===b.args[0])return b.args[2]['bundle-url']=a,!0});e||b.push({id:`setAnnotations-${d}`,method:'setAnnotations',args:[`$${c.id}`,'application',{"bundle-url":a}],requires:[c.id]})}}),b}_generateFileReader(){return new FileReader}_fileReaderOnload(a,b){const c=a.name.split('.').pop();if('yaml'===c){this.db.notifications.add({title:'Processing File',message:'Changeset processing started.',level:'important'});const c=a.name.split('.').slice(0,-1).join('.');this.fetchDryRun(b.target.result,c,null)}}_collectRequires(a,b,c){return b.requires&&b.requires.forEach(function(b){c.push(b),this._collectRequires(a,a.filter(function(a){return a.id===b})[0],c)},this),c}_sortDryRunRecords(a){const b=[];let c,d=a.length;for(let e=0;e<d;e+=1){if(c=a[e],0===c.requires.length){b.push(c);continue}const f=this._collectRequires(a,c,[]).every((a)=>{return b.some((b)=>{return b.id===a})});if(f){const a=b.some((a)=>{return a.id===c.id});a||b.push(c)}else{a.push(c),d+=1;continue}}return b}_saveModelToRequires(a,b){this.recordSet.forEach((c)=>{c.requires.forEach((d)=>{d===a&&(c[a]=b)})})}_executeDryRun(a){if(this._dryRunIndex===a.length-1){this.db.notifications.add({title:'Import Complete',message:'ChangeSet import complete.',level:'important'}),this._dryRunIndex=-1;const a=this._collectedServices;return this._collectedServices=[],void document.dispatchEvent(new CustomEvent('topo.bundleImportComplete',{detail:{services:a}}))}this._dryRunIndex+=1,this._executeRecord(a[this._dryRunIndex],a)}_executeRecord(a,b){var c=this['_execute_'+a.method];'function'==typeof c?this['_execute_'+a.method](a,this._executeDryRun.bind(this,b)):this.db.notifications.add({title:'Unknown method type',message:a.method+'is not supported. Stopping bundle import.',level:'error'})}_execute_expose(a,b){const c=a[a.args[0].replace(/^\$/,'')].get('id');this.modelAPI.expose(c,null,{}),b()}_execute_addMachines(a,b){let c=a.args[0].parentId;c=c&&c.replace(/^\$/,'');let d='';c&&(-1<c.indexOf('addMachine')?d=a[c].id:-1<c.indexOf('addUnit')&&(a[c].machine?d=a[c].machine:d=a[c].id),a.args[0].parentId=d),'lxc'===a.args[0].containerType&&(a.args[0].containerType='lxd');const e=a.args[0],f=this.db.machines.addGhost(e.parentId,e.containerType,{series:e.series,constraints:e.constraints});this.modelAPI.addMachines(a.args,function(a){this.db.machines.remove(a)}.bind(this,f),{modelId:f.id}),this._saveModelToRequires(a.id,f),b(f)}_execute_deploy(a,b){a.args.forEach((b,c)=>{if('string'==typeof b&&0===b.indexOf('$')&&2===b.split('-').length){const d=b.replace(/^\$/,''),e=a[d];0===c?a.args[0]=e.get('id'):void 0}}),this.charmstore.getEntity(a.args[0],(c,d)=>{return c?(console.warn('error loading charm: ',c),void this.db.notifications.add({title:'Unable to load charm',message:`Charm ${a.args[0]} was not able to be loaded.`,level:'error'})):void this._deploy_addCharm_success(this.makeEntityModel(d[0]),a,b)})}_deploy_addCharm_success(a,b,c){const d=a.get('series'),e=b.args[2],f=this.db.services.ghostService(a,e);b.args[2]=f.get('name');let g=b.args[1];g||(g=Array.isArray(d)?d[0]:d),f.set('series',g),b.annotations&&(f.annotations['gui-x']=b.annotations['gui-x'],f.annotations['gui-y']=b.annotations['gui-y']);const h={},i=a.get('options');i&&Object.keys(i).forEach((a)=>{h[a]=void 0===b.args[3][a]?i[a]['default']:b.args[3][a]}),f.set('config',h);const j=b.args[4]||{},k=function(a,b,c){if(b)return void this.db.notifications.add({title:'Error deploying '+c,message:'Could not deploy the requested application. Server responded with: '+b,level:'error'});const d=a.get('name');a.setAttrs({id:d,displayName:void 0,pending:!1,loading:!1,config:a.get('config'),constraints:j}),this.modelAPI.update_annotations(d,'application',a.get('annotations'))}.bind(this,f),l=a.get('id'),m=a.get('resources');m&&this.modelAPI.addPendingResources({applicationName:b.args[2],charmURL:l,channel:'stable',resources:m},(a,b)=>{return null===a?void f.set('resourceIds',b):void this.db.notifications.add({title:'Error adding resources',message:`Could not add requested resources for ${l}. `+'Server responded with: '+a,level:'error'})}),this.modelAPI.deploy({charmURL:l,applicationName:b.args[2],series:g,config:b.args[3],constraints:j},k,{modelId:f.get('id')}),this._saveModelToRequires(b.id,f),this._collectedServices.push(f),c()}_execute_addCharm(a,b){const c=this.db,d=this.charmstore,e=(a)=>{c.notifications.add({title:'Unable to load charm',message:a,level:'error'})};d.getCanonicalId(a.args[0],(f,g)=>{return f?void e(`Invalid charm id: ${a.args[0]}`):void d.getEntity(g,(f,h)=>{if(f)return void e(`Charm ${g} was not able to be loaded.`);const i=this.makeEntityModel(h[0]);null===c.charms.getById(i.get('id'))&&(i.loaded=!0,c.charms.add(i)),this.modelAPI.addCharm(g,d,()=>{}),this._saveModelToRequires(a.id,i),b()})})}_execute_addUnit(a,b){let c,d,e,f;2===a.args.length&&(a.args[2]=a.args[1],a.args[1]=1),a.args.forEach(function(b,g){if('string'==typeof b&&0===b.indexOf('$')&&2===b.split('-').length){const h=b.replace(/^\$/,''),i=a[h];0===g?(c=i.get('id'),a.args[0]=c,d=i.get('charm'),e=i.get('units').size(),f=i.get('name')+'/'+e):2===g?a.args[2]=i.id:void 0}},this);const g=c+'/'+e,h=this.db.addUnits({id:g,displayName:f,charmUrl:d,subordinate:this.db.charms.getById(d).get('is_subordinate')});this._saveModelToRequires(a.id,h),a.args[3]=function(a,b,c){a.service=c.applicationName,b.removeUnits(a)}.bind(this,h,this.db),3===a.args.length&&a.args.push(null),a.args.push({modelId:g}),this.modelAPI.add_unit.apply(this.modelAPI,a.args),null===a.args[2]&&this._execute_addMachines({args:[{}],id:a.id},function(b){a.args[2]=b.id}.bind(this)),this.modelAPI.placeUnit(h,a.args[2]),b()}_execute_addRelation(a,b){const c=a.args[0].split(':'),d=a.args[1].split(':'),e=[[c[0],{name:c[1]}],[d[0],{name:d[1]}]];e.forEach(function(b,c){e[c][0]=a[b[0].replace(/^\$/,'')].get('id')},this);const f='pending-'+a.args[0]+e[0][0]+a.args[1]+e[1][0],g=this.db.relations.add({relation_id:f,interface:e[0][1].name,endpoints:e,pending:!0,scope:'global',display_name:'pending'});this.modelAPI.add_relation(e[0],e[1],function(a){this.db.relations.create({relation_id:a.result.id,type:a.result['interface'],endpoints:e,pending:!1,scope:a.result.scope}),this.db.relations.remove(g)}.bind(this),{modelId:g.get('id')}),b()}_execute_setAnnotations(a,b){if('application'===a.args[1]||'service'===a.args[1]){const b=a[a.args[0].replace(/^\$/,'')].get('id'),c=this.db.services.getById(b),d=a.args[2];for(let a=!0;a;)if(a=this.db.services.some((a)=>{const b=a.get('annotations');if(d['gui-x']===b['gui-x']&&d['gui-y']===b['gui-y'])return!0}),a){const a=150;d['gui-x']=parseInt(d['gui-x'])+a,d['gui-y']=parseInt(d['gui-y'])+a}c.set('annotations',d)}b()}}module.exports=BundleImporter;