'use strict';var _this=this;const jsyaml=require('js-yaml'),React=require('react'),ReactDOM=require('react-dom'),FileSaver=require('file-saver'),Popup=require('../components/popup/popup'),viewUtils=require('../views/utils');let utils={createSocketURL:(a)=>{let b=a.apiAddress,c=a.template,d=a.protocol,e=a.uuid,f=a.server,g=a.port,h='';const i=`${d}://`||'wss://';if(!b)return void alert('Unable to create socketURL, no apiAddress provided. The GUI must be loaded with a valid configuration. Try GUIProxy if running in development mode: https://github.com/juju/guiproxy');'/'===c[0]&&(h=i+window.location.hostname,''!==window.location.port&&(h+=':'+window.location.port));const j=b.replace(i,'').split(':');return c=c.replace('$uuid',e),c=c.replace('$server',f||j[0]),c=c.replace('$port',g||j[1]),h+c},unloadWindow:function(){if(0<Object.keys(this.ecs.getCurrentChangeSet()).length)return'You have uncommitted changes to your model. You will lose these changes if you continue.'}};const timestrings={prefixAgo:null,prefixFromNow:null,suffixAgo:'ago',suffixFromNow:'from now',seconds:'less than a minute',minute:'about a minute',minutes:'%d minutes',hour:'about an hour',hours:'about %d hours',day:'a day',days:'%d days',month:'about a month',months:'%d months',year:'about a year',years:'%d years',wordSeparator:' ',numbers:[]};utils.humanizeTimestamp=(a)=>{var b=Math.round;const c=timestrings,d=c.prefixAgo,e=c.suffixAgo,f=new Date().getTime()-a,g=Math.abs(f)/1e3,h=g/60,i=h/60,j=i/24,k=j/365,l=(a,b)=>{const d='function'==typeof a?a(b,f):a,e=c.numbers&&c.numbers[b]||b;return d.replace(/%d/i,e)},m=45>g&&l(c.seconds,b(g))||90>g&&l(c.minute,1)||45>h&&l(c.minutes,b(h))||90>h&&l(c.hour,1)||24>i&&l(c.hours,b(i))||42>i&&l(c.day,1)||30>j&&l(c.days,b(j))||45>j&&l(c.month,1)||365>j&&l(c.months,b(j/30))||1.5>k&&l(c.year,1)||l(c.years,b(k));return[d,m,e].join(' ').trim()},utils.exportEnvironmentFile=(a)=>{const b=a.services.toArray(),c=new Map;b.forEach((a)=>{c.set(a.get('id'),a.get('name'))});const d=a.exportBundle();let e=jsyaml.dump(d);c.forEach((a,b)=>{e=e.split(b).join(a)});const f=new Blob([e],{type:'text/plain;charset=utf-8'}),g=a.environment.get('name');FileSaver.saveAs(f,utils._generateBundleExportFileName(g))},utils._generateBundleExportFileName=(a,b=new Date)=>{return[a,b.getFullYear(),('0'+(b.getMonth()+1)).slice(-2),('0'+b.getDate()).slice(-2)].join('-')+'.yaml'},utils._onYAMLConfigLoaded=(a,b,c)=>{const d=jsyaml.safeLoad(c.target.result);b(d)},utils.getYAMLConfig=(a,b)=>{const c=new FileReader;c.onload=utils._onYAMLConfigLoaded.bind(_this,a.name,b),c.readAsText(a)},utils.getName=(a)=>{const b=a.split('/'),c=b[b.length-1].split('-');return isNaN(c[c.length-1])||c.pop(),c.join('-')},utils.pluralize=(a,b,c)=>{let d=!1;return'number'==typeof b&&(d=1!=b),b&&(b.size?d=1!==b.size():b.length&&(d=1!==b.length)),d?'string'==typeof c?c:a+'s':a},utils.jujushellURL=(a,b,c)=>{const d='jujushell-url';let e=a.getItem(d);return e?(e=e.replace(/^(http:\/\/)/,'ws://'),e=e.replace(/^(https:\/\/)/,'wss://'),0!==e.indexOf('ws://')&&0!==e.indexOf('wss://')&&(e='wss://'+e),e.replace(/\/?$/,'/')+'ws/'):(e=b.environment.get('jujushellURL'),e?(a.setItem(d,e),`wss://${e}/ws/`):c.jujushellURL||null)},utils.destroyService=(a,b,c,d)=>{if('service'===c.name)b.destroyApplication(c.get('id'),utils._destroyServiceCallback.bind(_this,c,a,d),{modelId:null});else if(c.get('pending'))a.services.remove(c),c.destroy();else throw new Error('Unexpected model type: '+c.name)},utils._destroyServiceCallback=(a,b,c,d)=>{d.err?b.notifications.add({title:'Error destroying service',message:'Service name: '+d.applicationName,level:'error',link:void 0,modelId:a}):(b.relations.remove(a.get('relations')),b.notifications.add({title:'Destroying service',message:'Service: '+d.applicationName+' is being destroyed.',level:'important'})),c&&c()},utils.clearState=()=>{document.dispatchEvent(new Event('topo.clearState'))},utils.getUnitStatusCounts=(a)=>{const b={uncommitted:{priority:3,size:0},started:{priority:2,size:0},pending:{priority:1,size:0},error:{priority:0,size:0}};let c;return a.forEach((a)=>{c=a.agent_state||'uncommitted',b[c]||(b[c]={priority:99,size:0}),b[c].size+=1}),b};const URL_RE=/\b((?:(?:https?|ftp):(?:\/{1,3}|[a-z0-9%])|[a-z0-9.\-]+[.](?:com|net|org|edu|gov|mil|aero|asia|biz|cat|coop|info|int|jobs|mobi|museum|name|post|pro|tel|travel|xxx|ac|ad|ae|af|ag|ai|al|am|an|ao|aq|ar|as|at|au|aw|ax|az|ba|bb|bd|be|bf|bg|bh|bi|bj|bm|bn|bo|br|bs|bt|bv|bw|by|bz|ca|cc|cd|cf|cg|ch|ci|ck|cl|cm|cn|co|cr|cs|cu|cv|cx|cy|cz|dd|de|dj|dk|dm|do|dz|ec|ee|eg|eh|er|es|et|eu|fi|fj|fk|fm|fo|fr|ga|gb|gd|ge|gf|gg|gh|gi|gl|gm|gn|gp|gq|gr|gs|gt|gu|gw|gy|hk|hm|hn|hr|ht|hu|id|ie|il|im|in|io|iq|ir|is|it|je|jm|jo|jp|ke|kg|kh|ki|km|kn|kp|kr|kw|ky|kz|la|lb|lc|li|lk|lr|ls|lt|lu|lv|ly|ma|mc|md|me|mg|mh|mk|ml|mm|mn|mo|mp|mq|mr|ms|mt|mu|mv|mw|mx|my|mz|na|nc|ne|nf|ng|ni|nl|no|np|nr|nu|nz|om|pa|pe|pf|pg|ph|pk|pl|pm|pn|pr|ps|pt|pw|py|qa|re|ro|rs|ru|rw|sa|sb|sc|sd|se|sg|sh|si|sj|Ja|sk|sl|sm|sn|so|sr|ss|st|su|sv|sx|sy|sz|tc|td|tf|tg|th|tj|tk|tl|tm|tn|to|tp|tr|tt|tv|tw|tz|ua|ug|uk|us|uy|uz|va|vc|ve|vg|vi|vn|vu|wf|ws|ye|yt|yu|za|zm|zw)\/)(?:[^\s()<>{}\[\]]+|\([^\s()]*?\([^\s()]+\)[^\s()]*?\)|\([^\s]+?\))+(?:\([^\s()]*?\([^\s()]+\)[^\s()]*?\)|\([^\s]+?\)|[^\s`!()\[\]{};:'".,<>?«»“”‘’])|(?:[a-z0-9]+(?:[.\-][a-z0-9]+)*[.](?:com|net|org|edu|gov|mil|aero|asia|biz|cat|coop|info|int|jobs|mobi|museum|name|post|pro|tel|travel|xxx|ac|ad|ae|af|ag|ai|al|am|an|ao|aq|ar|as|at|au|aw|ax|az|ba|bb|bd|be|bf|bg|bh|bi|bj|bm|bn|bo|br|bs|bt|bv|bw|by|bz|ca|cc|cd|cf|cg|ch|ci|ck|cl|cm|cn|co|cr|cs|cu|cv|cx|cy|cz|dd|de|dj|dk|dm|do|dz|ec|ee|eg|eh|er|es|et|eu|fi|fj|fk|fm|fo|fr|ga|gb|gd|ge|gf|gg|gh|gi|gl|gm|gn|gp|gq|gr|gs|gt|gu|gw|gy|hk|hm|hn|hr|ht|hu|id|ie|il|im|in|io|iq|ir|is|it|je|jm|jo|jp|ke|kg|kh|ki|km|kn|kp|kr|kw|ky|kz|la|lb|lc|li|lk|lr|ls|lt|lu|lv|ly|ma|mc|md|me|mg|mh|mk|ml|mm|mn|mo|mp|mq|mr|ms|mt|mu|mv|mw|mx|my|mz|na|nc|ne|nf|ng|ni|nl|no|np|nr|nu|nz|om|pa|pe|pf|pg|ph|pk|pl|pm|pn|pr|ps|pt|pw|py|qa|re|ro|rs|ru|rw|sa|sb|sc|sd|se|sg|sh|si|sj|Ja|sk|sl|sm|sn|so|sr|ss|st|su|sv|sx|sy|sz|tc|td|tf|tg|th|tj|tk|tl|tm|tn|to|tp|tr|tt|tv|tw|tz|ua|ug|uk|us|uy|uz|va|vc|ve|vg|vi|vn|vu|wf|ws|ye|yt|yu|za|zm|zw)\b\/?(?!@)))/ig;utils.linkify=(a)=>{let b=a.replace(/&/g,'&amp;').replace(/</g,'&lt;').replace(/>/g,'&gt;');const c=b.match(URL_RE);return c&&c.forEach((a)=>{const c=a.replace(/"/g,'&quot;');b=b.replace(a,`<a href="${c}" target="_blank">${a}</a>`)}),b},utils.compareSemver=(c,a)=>{c=c.split('-')[0],a=a.split('-')[0];const b=c.split('.'),d=a.split('.');for(let e=0;3>e;e++){const a=+b[e],c=+d[e];if(a>c)return 1;if(c>a)return-1;if(!isNaN(a)&&isNaN(c))return 1;if(isNaN(a)&&!isNaN(c))return-1}return 0},utils.switchModel=function(a,b,c,d=!0){if(!(c&&c.id===this.modelUUID)){if(a.get('ecs').isCommitting()){const a='cannot switch models while deploying.';return void b({title:a,message:a,level:'error'})}const e=utils._switchModel.bind(this,a,c),f=a.get('ecs').getCurrentChangeSet();return d&&0<Object.keys(f).length?void utils._showUncommittedConfirm(e):void e()}},utils._showUncommittedConfirm=(a)=>{const b=[{title:'Cancel',action:utils._hidePopup.bind(_this),type:'inline-neutral'},{title:'Continue',action:a,type:'destructive'}];ReactDOM.render(React.createElement(Popup,{buttons:b,title:'Uncommitted changes'},React.createElement('p',null,'You have uncommitted changes to your model. You will lose these changes if you continue.')),document.getElementById('popup-container'))},utils._hidePopup=()=>{ReactDOM.unmountComponentAtNode(document.getElementById('popup-container'))},utils._switchModel=function(a,b){utils._hidePopup();const c=this.state.current,d={profile:null,gui:{status:null,inspector:null},root:null,hash:null};let e='',f='';if(b){f=b.id,e=b.name;const a=b.owner.split('@')[0];d.model={path:`${a}/${e}`,uuid:f},c&&c.gui&&c.gui.status!==void 0&&(d.gui.status=c.gui.status)}else d.model=null,c&&c.profile||(d.root='new');this.state.changeState(d),a.set('environmentName',e),this.modelUUID=f},utils.showProfile=(a,b)=>{a({profile:b,root:null,store:null,search:null,account:null,user:null})},utils.showAccount=(a,b)=>{const c=a.getCurrentChangeSet();return 0<Object.keys(c).length?void utils._showUncommittedConfirm(utils._showAccount.bind(_this,a,b,!0)):void utils._showAccount(a,b,!1)},utils._showAccount=(a,b,c=!1)=>{utils._hidePopup(),c&&a.clear(),b({profile:null,model:null,root:'account',store:null})},utils.deploy=function(a,b,c,d,e=!0,f,g){const h=a.modelAPI,i=a.controllerAPI,j=a.user;if(e&&b(),h.get('connected'))return h.get('ecs').commit(h),a.state.changeState({postDeploymentPanel:{show:!0}}),void d(null);i.createModel(f,j.controller.user,g,(b,e)=>{if(b){const c='cannot create model: '+b;return a.db.notifications.add({title:c,message:c,level:'error'}),void d(c)}const f=a.state.current,g=f.root;g&&'new'===g&&a.state.changeState({root:null});const i=f.special;i&&i.dd&&a.state.changeState({special:{dd:null}}),a.modelUUID=e.uuid;const j=a.applicationConfig,k=c({apiAddress:j.apiAddress,template:j.socketTemplate,protocol:j.socket_protocol,uuid:e.uuid});a.state.changeState({postDeploymentPanel:{show:!0}}),a.switchEnv(k,null,null,()=>{h.get('ecs').commit(h),utils._switchModel.call(a,h,{id:e.uuid,name:e.name,owner:e.owner}),d(null)},!0,!1)})},utils.generateCloudCredentialName=(a,b,c)=>{return`${a}_${b}_${c}`},utils.getCloudProviderDetails=(a)=>{const b={gce:{id:'google',showLogo:!0,signupUrl:'https://console.cloud.google.com/billing/freetrial',svgHeight:33,svgWidth:256,title:'Google Compute Engine',forms:{jsonfile:[{id:'file',title:'Google Compute Engine project credentials .json file',json:!0}],oauth2:[{id:'client-id',title:'Client ID'},{id:'client-email',title:'Client e-mail address'},{autocomplete:!1,id:'private-key',title:'Private key',multiLine:!0,unescape:!0},{id:'project-id',title:'Project ID'}]},message:React.createElement('p',null,'Need help? Read more about ',React.createElement('a',{className:'deployment-panel__link',href:'https://jujucharms.com/docs/stable/credentials',target:'_blank',title:'Cloud credentials help'},'credentials in general'),' or ',React.createElement('a',{className:'deployment-panel__link',href:'https://jujucharms.com/docs/stable/help-google',target:'_blank',title:'Help using the Google Compute Engine public cloud'},'setting up GCE credentials'),'.')},azure:{id:'azure',showLogo:!0,signupUrl:'https://azure.microsoft.com/en-us/free/',svgHeight:24,svgWidth:204,title:'Microsoft Azure',forms:{"service-principal-secret":[{id:'application-id',title:'Azure Active Directory application ID'},{id:'subscription-id',title:'Azure subscription ID'},{id:'application-password',title:'Azure Active Directory application password',type:'password'}]},message:React.createElement('p',null,'Need help? Read more about ',React.createElement('a',{className:'deployment-panel__link',href:'https://jujucharms.com/docs/stable/credentials',target:'_blank',title:'Cloud credentials help'},'credentials in general'),' or ',React.createElement('a',{className:'deployment-panel__link',href:'https://jujucharms.com/docs/stable/help-azure',target:'_blank',title:'Help using the Microsoft Azure public cloud'},'setting up Azure credentials'),'.')},ec2:{id:'aws',showLogo:!0,signupUrl:'https://portal.aws.amazon.com/gp/aws/developer/registration/index.html',svgHeight:44,svgWidth:117,title:'Amazon Web Services',forms:{"access-key":[{id:'access-key',title:'The EC2 access key'},{autocomplete:!1,id:'secret-key',title:'The EC2 secret key'}]},message:React.createElement('p',null,'Need help? Read more about ',React.createElement('a',{className:'deployment-panel__link',href:'https://jujucharms.com/docs/stable/credentials',target:'_blank',title:'Cloud credentials help'},'credentials in general'),' or ',React.createElement('a',{className:'deployment-panel__link',href:'https://jujucharms.com/docs/stable/help-aws',target:'_blank',title:'Help using the Amazon Web Service public cloud'},'setting up AWS credentials'),'.')},openstack:{id:'openstack',showLogo:!1,title:'OpenStack',forms:{userpass:[{id:'username',title:'Username'},{id:'password',title:'Password',type:'password'},{id:'tenant-name',title:'Tenant name'},{id:'domain-name',required:!1,title:'Domain name'}],"access-key":[{id:'access-key',title:'Access key'},{autocomplete:!1,id:'secret-key',title:'Secret key'},{id:'tenant-name',title:'Tenant name'}]}},cloudsigma:{id:'cloudsigma',showLogo:!1,title:'CloudSigma',forms:{userpass:[{id:'username',title:'Username'},{id:'password',title:'Password',type:'password'}]}},joyent:{id:'joyent',showLogo:!1,title:'Joyent',forms:{userpass:[{id:'sdc-user',title:'SmartDataCenter user ID'},{id:'sdc-key-id',title:'SmartDataCenter key ID'},{autocomplete:!1,id:'private-key',title:'Private key used to sign requests'},{id:'algorithm',title:'Algorithm used to generate the private key'}]}},maas:{id:'maas',showLogo:!1,title:'MAAS',forms:{oauth1:[{id:'maas-oauth',title:'OAuth/API-key credentials for MAAS'}]}},rackspace:{id:'rackspace',showLogo:!1,title:'Rackspace',forms:{userpass:[{id:'username',title:'Username'},{id:'password',title:'Password',type:'password'},{id:'tenant-name',title:'Tenant name'},{id:'domain-name',required:!1,title:'Domain name'}],"access-key":[{id:'access-key',title:'Access key'},{autocomplete:!1,id:'secret-key',title:'Secret key'},{id:'tenant-name',title:'Tenant name'}]}},vsphere:{id:'vsphere',showLogo:!1,title:'vSphere',forms:{userpass:[{id:'username',title:'Username'},{id:'password',title:'Password',type:'password'}]}},localhost:{id:'local',showLogo:!1,title:'Local'}};return'aws'===a?a='ec2':'google'===a?a='gce':void 0,b[a]},utils.validateForm=(a,b)=>{let c=!0;return a.forEach((a)=>{const d=b[a];if(d&&d.validate){const a=d.validate();a||(c=!1)}}),c},utils.parseConstraints=(a,b='')=>{let c={};return a.forEach((a)=>{c[a]=null}),b.split(' ').forEach((a)=>{const b=a.split('=');void 0!==c[b[0]]&&(c[b[0]]=b[1])}),c},utils.generateMachineDetails=(a,b,c)=>{const d=c.hardware||utils.parseConstraints(a,c.constraints)||{},e=b.filterByMachine(c.id,!0).length;let f,g=[];Object.keys(d).forEach((a)=>{let b=d[a];b&&('cpu-power'===a?b=`${b/100}GHz`:('mem'===a||'root-disk'===a)&&(b=`${(b/1024).toFixed(2)}GB`),g.push(`${a.replace('-',' ')}: ${b}`))});const h=c.constraints?'requested constraints: ':'';f=`${h}${g.join(', ')}`,f||('uncommitted'===c.commitStatus?f='default constraints':f='hardware details not available');const i=1===e?'':'s',j=c.series?`${c.series}, `:'';return`${e} unit${i}, ${j}${f}`},utils.createMachinesPlaceUnits=function(a,b,c,d,e){let f;for(let g=0;g<parseInt(d,10);g+=1)f=a.machines.addGhost(null,null,{constraints:viewUtils.formatConstraints(e)}),b.addMachines([{constraints:e}],function(b){a.machines.remove(b)}.bind(this,f),{modelId:f.id}),b.placeUnit(addGhostAndEcsUnits(a,b,c,1)[0],f.id)};function addGhostAndEcsUnits(a,b,c,d,e){var f,g,h,j,k=c.get('id'),d=parseInt(d,10),l=[];const i=(a)=>parseInt(a.id&&a.id.split('/')[1]||a,10),m=c.get('units').toArray();let n=-1;m.length&&(n=m.reduce((a,b)=>Math.max(i(a),i(b)),0)),f=0<k.indexOf('$')?c.get('displayName').replace(/^\(/,'').replace(/\)$/,''):k;for(let m=1;m<=d;m+=1)j=n+m,h=k+'/'+j,g=a.addUnits({id:h,displayName:f+'/'+j,charmUrl:c.get('charm'),subordinate:c.get('subordinate')}),b.add_unit(k,1,null,removeGhostAddUnitCallback.bind(null,g,a,e),{modelId:h}),l.push(g);return l}function removeGhostAddUnitCallback(a,b,c,d){a.service=d.applicationName,b.removeUnits(a),'function'==typeof c&&c(d,b,a)}utils.addGhostAndEcsUnits=addGhostAndEcsUnits,utils.removeGhostAddUnitCallback=removeGhostAddUnitCallback,module.exports=utils;