'use strict';describe('Bakery',()=>{let a,b,c,d,e;beforeAll((a)=>{c=require('js-macaroon'),a()}),beforeEach(()=>{b={store:{},getItem:function(a){return this.store[a]},setItem:function(a,b){this.store[a]=b},removeItem:function(a){delete this.store[a]}},e={_sendRequest:sinon.stub(),sendGetRequest:function(...a){this._sendRequest('get',...a)},sendPostRequest:function(...a){this._sendRequest('post',...a)},sendPutRequest:function(...a){this._sendRequest('put',...a)},sendDeleteRequest:function(...a){this._sendRequest('delete',...a)},sendPatchRequest:function(...a){this._sendRequest('patch',...a)}},d=new jujulib.BakeryStorage(b,{services:{charmstore:'http://example.com/charmstore',otherService:'http://example.com/other'}}),a=new jujulib.Bakery(e,d)}),afterEach(()=>{a=null,d=null}),describe('can send requests',()=>{it('sets the method',()=>{const b='http://example.com/',c={header:42},d=()=>42;let f,g='content';['PATCH','post','PUT'].forEach((h)=>{a.sendRequest(b,h,c,g,d),assert.equal(e._sendRequest.callCount,1),f=e._sendRequest.args[0],assert.equal(f[0],h.toLowerCase()),assert.equal(f[1],b),assert.deepEqual(f[2],{header:42,"Bakery-Protocol-Version":1}),assert.equal(f[3],g),assert.isFunction(f[8]),e._sendRequest.reset()}),['GET','delete'].forEach((g)=>{a.sendRequest(b,g,c,d),assert.equal(e._sendRequest.callCount,1),f=e._sendRequest.args[0],assert.equal(f[0],g.toLowerCase()),assert.equal(f[1],b),assert.deepEqual(f[2],{header:42,"Bakery-Protocol-Version":1}),assert.isFunction(f[7]),e._sendRequest.reset()})}),it('properly handles cookie auth',()=>{const b=e._sendRequest,c=(c,d,e)=>{b.reset(),a.sendRequest('http://example.com'+d,c),assert.strictEqual(b.args[0][6],e,`${c} ${d}`)};c('PUT','/set-auth-cookie',!0),c('PUT','/foo/set-auth-cookie/bar',!0),c('PUT','/',!1),c('PUT','/foo',!1),c('POST','/set-auth-cookie',!1),c('POST','/foo/set-auth-cookie/bar',!1),c('POST','/foo',!1)}),it('sets the headers',()=>{a.sendRequest('http://example.com/','GET',{foo:'bar'});assert.deepEqual(e._sendRequest.args[0][2],{"Bakery-Protocol-Version":1,foo:'bar'})}),it('adds macaroons to the request',()=>{b.store.charmstore='doctor',b.store.identity='bad wolf',a.sendRequest('http://example.com/charmstore','GET');assert.deepEqual(e._sendRequest.args[0][2],{"Bakery-Protocol-Version":1,Macaroons:'doctor'})}),it('wraps callbacks with discharge functionality',()=>{const b=sinon.stub(a,'_wrapCallback');a.sendRequest('http://example.com/','GET'),assert.equal(b.callCount,1)})}),describe('macaroon discharges',()=>{let b,d;beforeEach(()=>{b=sinon.stub(c,'dischargeMacaroon'),d=sinon.stub(c,'generateMacaroons')}),afterEach(()=>{b.restore(),d.restore()}),it('discharges macaroons',()=>{const c='this is a macaroon';a.discharge(c,(a)=>{assert.equal(a,c)},(a)=>{console.error(a),assert.fail()}),assert.equal(b.callCount,1,'macaroonlib discharge not called')}),it('handles failures discharging macaroons',()=>{const c={message:'bad wolf'};b.callsArgWith(2,'this is a macaroon'),d.throws(c);a.discharge('macaroons',()=>{},(a)=>{assert.equal(a,`discharge failed: ${c.message}`)})}),it('handles third party discharge',()=>{a._getThirdPartyDischarge('http://example.com/','http://example.com/identity','this is a caveat',()=>{},()=>{}),assert.equal(e._sendRequest.callCount,1);const b=e._sendRequest.args[0];assert.equal(b[0],'post'),assert.equal(b[1],'http://example.com/identity/discharge'),assert.deepEqual(b[2],{"Bakery-Protocol-Version":1,"Content-Type":'application/x-www-form-urlencoded'}),assert.equal(b[3],'id=this%20is%20a%20caveat&location=http%3A%2F%2Fexample.com%2F')})}),describe('wrapped callbacks',()=>{const b=(a)=>{if(!a)return{status:200};const b=JSON.stringify(a);return{status:401,getResponseHeader:sinon.stub().returns('application/json'),responseText:b}};it('handles requests normally if nothing is needed',()=>{const c=sinon.stub(),d=a._wrapCallback('http://example.com','POST',{},'body',c),e=b();d({target:e}),assert.equal(c.callCount,1)}),it('handles interaction if needed',()=>{const c=sinon.stub(a,'_interact'),d=sinon.stub(),e=a._wrapCallback('http://example.com','POST',{},'body',d),f=b({Code:'interaction required',Info:{VisitURL:'http://example.com/identity',WaitURL:'http://example.com/identity/wait'}});e({target:f}),assert.equal(c.callCount,1);const g=c.args[0][0].Info;assert.equal(g.VisitURL,'http://example.com/identity'),assert.equal(g.WaitURL,'http://example.com/identity/wait')}),it('handles discharge if needed',()=>{const c=sinon.stub(a,'discharge'),d=sinon.stub(),e=a._wrapCallback('http://example.com','POST',{},'body',d),f=b({Code:'macaroon discharge required',Info:{Macaroon:'macaroon'}});e({target:f}),assert.equal(c.callCount,1);const g=c.args[0];assert.equal(g[0],'macaroon')}),it('do not acquire macaroons if discharge is disabled',()=>{a=a.withoutDischarge();const c=sinon.stub(a,'discharge'),d=sinon.stub(),e=a._wrapCallback('http://example.com','POST',{},'body',d),f=b({Code:'macaroon discharge required',Info:{Macaroon:'macaroon'}});e({target:f}),assert.equal(c.callCount,0,'discharge call count'),assert.equal(d.callCount,1,'callback call count');const g=d.args[0];assert.equal(g.length,2,'callback args'),assert.strictEqual(g[0],'discharge required but disabled'),assert.deepEqual(g[1].target,f)})}),describe('interact handling',()=>{const b=(a)=>{let b={target:{status:200,responseText:'',response:''}};return a&&(b.target.status=0),b};it('accepts a visit page method',()=>{a=new jujulib.Bakery(e,d,{visitPage:()=>{return'visits'}}),assert.equal(a._visitPage(),'visits')}),it('opens the visit page',()=>{const b=sinon.stub(window,'open'),c={Info:{VisitURL:'http://example.com'}};a._visitPage(c),assert.equal(b.callCount,1),assert.equal(b.args[0][0],c.Info.VisitURL),b.restore()}),it('sets the content type correctly for the wait call',()=>{a._interact({Info:{WaitURL:'http://example.com/wait',VisitURL:'http://example.com/visit'}},()=>{},()=>{}),assert.equal(e._sendRequest.callCount,1),assert.equal(e._sendRequest.args[0][1],'http://example.com/wait'),assert.equal(e._sendRequest.args[0][2]['Content-Type'],'application/json')}),it('handles retry',()=>{e._sendRequest.onFirstCall().callsArgWith(7,b(!0)).onSecondCall().callsArgWith(7,b(!1)),a._interact({Info:{WaitURL:'http://example.com/wait',VisitURL:'http://example.com/visit'}},()=>{},()=>{}),assert.equal(e._sendRequest.callCount,2)}),it('limits retries',()=>{e._sendRequest.callsArgWith(7,b(!0)),a._interact({Info:{WaitURL:'http://example.com/wait',VisitURL:'http://example.com/visit'}},()=>{},()=>{}),assert.equal(e._sendRequest.callCount,6)}),it('handles errors',()=>{e._sendRequest.callsArgWith(7,b(!0)),sinon.stub(a,'_getError').returns({message:'bad wolf'});const c=sinon.stub(),d=sinon.stub();a._interact({Info:{WaitURL:'http://example.com/wait',VisitURL:'http://example.com/visit'}},c,d),assert.equal(c.callCount,0),assert.equal(d.callCount,1),assert.equal(d.args[0][0],'cannot interact: bad wolf')}),it('handles success',()=>{e._sendRequest.callsArgWith(7,b(!0)),sinon.stub(a,'_getError').returns(null);const c=sinon.stub(),d=sinon.stub();a._interact({Info:{WaitURL:'http://example.com/wait',VisitURL:'http://example.com/visit'}},c,d),assert.equal(c.callCount,1),assert.equal(d.callCount,0)})}),describe('storage',()=>{it('sets items',()=>{d.set('http://example.com/charmstore','foo',()=>{}),assert.equal(b.store.charmstore,'foo')}),it('gets items',()=>{b.store.charmstore='foo',assert.equal('foo',d.get('http://example.com/charmstore'))}),it('sets cookies for charmstore',()=>{const a=sinon.stub();d=new jujulib.BakeryStorage(b,{services:{charmstore:'http://example.com/charmstore'},charmstoreCookieSetter:a});const c=btoa(JSON.stringify('macaroon'));d.set('http://example.com/charmstore',c,()=>{}),assert.equal(a.callCount,1),assert.equal(a.args[0][0],'macaroon')}),describe('keys',()=>{it('removes discharge suffix',()=>{assert.equal('http://example.com/identity',d._getKey('http://example.com/identity/discharge'))}),it('gets keys from services',()=>{assert.equal('charmstore',d._getKey('http://example.com/charmstore'))}),it('does not modify other keys',()=>{assert.equal('a-key',d._getKey('a-key'))})})})});