'use strict';const WebHandler=require('./web-handler');(function(){describe('Web handler',function(){let a,b;beforeEach(function(){b=new WebHandler;const c=XMLHttpRequest.prototype;a={addEventListener:sinon.stub(c,'addEventListener'),open:sinon.stub(c,'open'),setRequestHeader:sinon.stub(c,'setRequestHeader'),send:sinon.stub(c,'send'),removeEventListener:sinon.stub(c,'removeEventListener')}}),afterEach(function(){Object.keys(a).forEach((b)=>{a[b].restore()})});const c=function(b){let c=a.addEventListener.args;const d=c[0][1],e={type:'progress'};d(e),assert.strictEqual(b.callCount,1),assert.deepEqual(b.lastCall.args,[e]),assert.strictEqual(a.removeEventListener.called,!1)},d=function(b){let c=a.addEventListener.args;const d=c[0][1],e=c[1][1],f={type:'load'};e(f),assert.strictEqual(b.callCount,1),assert.deepEqual(b.lastCall.args,[f]),assert.strictEqual(a.removeEventListener.callCount,3),c=a.removeEventListener.args,assert.deepEqual(c[0],['progress',d]),assert.deepEqual(c[1],['error',e]),assert.deepEqual(c[2],['load',e])};describe('sendPostRequest',function(){it('opens and sends an XHR request with the proper data',function(){const c='/juju-core/charms?series=trusty';b.sendPostRequest(c,{"Content-Type":'application/zip'},'a zip file object','user','passwd',!1,function(){return'progress'},function(){return'completed'}),assert.strictEqual(a.addEventListener.callCount,3);let d=a.addEventListener.args;assert.strictEqual(d[0][0],'progress'),assert.strictEqual(d[1][0],'error'),assert.strictEqual(d[2][0],'load'),assert.strictEqual(a.open.callCount,1),assert.deepEqual(a.open.lastCall.args,['POST',c,!0]),assert.strictEqual(a.setRequestHeader.callCount,2),d=a.setRequestHeader.args,assert.deepEqual(d[0],['Content-Type','application/zip']),assert.deepEqual(d[1],['Authorization','Basic dXNlcjpwYXNzd2Q=']),assert.strictEqual(a.send.callCount,1),assert.deepEqual(a.send.lastCall.args,['a zip file object']),assert.strictEqual(a.removeEventListener.called,!1)}),it('handles request progress',function(){const a=sinon.stub();b.sendPostRequest('/path/',{},'data','user','passwd',!1,a),c(a)}),it('handles request completion',function(){const a=sinon.stub();b.sendPostRequest('/path/',{},'data','user','passwd',!1,function(){},a),d(a)})}),describe('sendPutRequest',function(){it('opens and sends an XHR request with the proper data',function(){const c='/juju-core/charms?series=trusty';b.sendPutRequest(c,{"Content-Type":'application/zip'},'a zip file object','user','passwd',!1,function(){return'progress'},function(){return'completed'}),assert.strictEqual(a.addEventListener.callCount,3);let d=a.addEventListener.args;assert.strictEqual(d[0][0],'progress'),assert.strictEqual(d[1][0],'error'),assert.strictEqual(d[2][0],'load'),assert.strictEqual(a.open.callCount,1),assert.deepEqual(a.open.lastCall.args,['PUT',c,!0]),assert.strictEqual(a.setRequestHeader.callCount,2),d=a.setRequestHeader.args,assert.deepEqual(d[0],['Content-Type','application/zip']),assert.deepEqual(d[1],['Authorization','Basic dXNlcjpwYXNzd2Q=']),assert.strictEqual(a.send.callCount,1),assert.deepEqual(a.send.lastCall.args,['a zip file object']),assert.strictEqual(a.removeEventListener.called,!1)}),it('handles request progress',function(){const a=sinon.stub();b.sendPutRequest('/path/',{},'data','user','passwd',!1,a),c(a)}),it('handles request completion',function(){const a=sinon.stub();b.sendPutRequest('/path/',{},'data','user','passwd',!1,function(){},a),d(a)})}),describe('sendGetRequest',function(){it('opens and sends an XHR request with the proper data',function(){const c='/juju-core/charms?url=local:trusty/django-42';b.sendGetRequest(c,null,'user','passwd',!1,function(){return'progress'},function(){return'completed'}),assert.strictEqual(a.addEventListener.callCount,3);let d=a.addEventListener.args;assert.strictEqual(d[0][0],'progress'),assert.strictEqual(d[1][0],'error'),assert.strictEqual(d[2][0],'load'),assert.strictEqual(a.open.callCount,1),assert.deepEqual(a.open.lastCall.args,['GET',c,!0]),assert.strictEqual(a.setRequestHeader.callCount,1),d=a.setRequestHeader.args,assert.deepEqual(d[0],['Authorization','Basic dXNlcjpwYXNzd2Q=']),assert.strictEqual(a.send.callCount,1),assert.lengthOf(a.send.lastCall.args,0),assert.strictEqual(a.removeEventListener.called,!1)}),it('handles request progress',function(){const a=sinon.stub();b.sendGetRequest('/path/',{},'user','passwd',!1,a),c(a)}),it('handles request completion',function(){const a=sinon.stub();b.sendGetRequest('/path/',{},'user','passwd',!1,function(){},a),d(a)})}),describe('sendPatchRequest',function(){it('opens and sends an XHR request with the proper data',function(){const c='/juju-core/charms?series=trusty';b.sendPatchRequest(c,{"Content-Type":'application/zip'},'a zip file object','user','passwd',!1,function(){return'progress'},function(){return'completed'}),assert.strictEqual(a.addEventListener.callCount,3);let d=a.addEventListener.args;assert.strictEqual(d[0][0],'progress'),assert.strictEqual(d[1][0],'error'),assert.strictEqual(d[2][0],'load'),assert.strictEqual(a.open.callCount,1),assert.deepEqual(a.open.lastCall.args,['PATCH',c,!0]),assert.strictEqual(a.setRequestHeader.callCount,2),d=a.setRequestHeader.args,assert.deepEqual(d[0],['Content-Type','application/zip']),assert.deepEqual(d[1],['Authorization','Basic dXNlcjpwYXNzd2Q=']),assert.strictEqual(a.send.callCount,1),assert.deepEqual(a.send.lastCall.args,['a zip file object']),assert.strictEqual(a.removeEventListener.called,!1)}),it('handles request progress',function(){const a=sinon.stub();b.sendPatchRequest('/path/',{},'data','user','passwd',!1,a),c(a)}),it('handles request completion',function(){const a=sinon.stub();b.sendPatchRequest('/path/',{},'data','user','passwd',!1,function(){},a),d(a)})}),it('defines a function which helps creating auth headers',function(){const a=b._createAuthorizationHeader('myuser','mypasswd');assert.strictEqual(a,'Basic bXl1c2VyOm15cGFzc3dk')}),describe('getUrl',function(){it('returns a complete URL based on the given credentials',function(){const a=b.getUrl('/my/path','myuser','mypassword'),c='http://myuser:mypassword@'+window.location.host+'/my/path';assert.strictEqual(a,c)})})})})();