'use strict';chai.config.includeStack=!0,chai.config.truncateThreshold=0,describe('user auth class',()=>{it('exists',()=>{const a=new window.jujugui.User;assert.isObject(a)});const a=function(){return new function(){return{_names:{},setItem:function(a,b){this[a]=b,this._names[a]=!0},getItem:function(a){return this[a]||null},removeItem:function(a){delete this[a],delete this._names[a]},clear:function(){Object.keys(this._names).forEach((a)=>{this.removeItem(a)})}}}};describe('controller credentials',()=>{let b,c;beforeEach(()=>{b=a(),c=new window.jujugui.User({sessionStorage:b})}),beforeEach(()=>{b=a(),c=new window.jujugui.User({sessionStorage:b})}),it('can be set',()=>{c.controller={user:'rose'},assert.deepEqual(JSON.parse(b.controllerCredentials),{user:'rose'})}),it('can be retrieved',()=>{c.controller={user:'rose',password:'bad wolf'};const a=c.controller;assert.equal(a.password,'bad wolf')}),it('normalizes user names',()=>{c.controller={user:'rose',password:'bad wolf'};let a=c.controller;assert.equal(a.user,'rose@local'),c.controller={user:'doctor@tardis',password:'tenant'},a=c.controller,assert.equal(a.user,'doctor@tardis')}),it('determines if credentials are available',()=>{let a=c.controller;assert.equal(a.areAvailable,!1),c.controller={macaroons:['macaroons']},a=c.controller,assert.equal(a.areAvailable,!0)}),it('determines if creds are external',()=>{c.controller={user:'doctor@tardis',password:'bad wolf'},c.externalAuth='foo';const a=c.controller;assert.equal(a.areExternal,!0)})}),describe('model credentials',()=>{let b,c;beforeEach(()=>{b=a(),c=new window.jujugui.User({sessionStorage:b})}),it('can be set',()=>{c.model={user:'rose'},assert.deepEqual(JSON.parse(b.modelCredentials),{user:'rose'})}),it('can be retrieved',()=>{c.model={user:'rose',password:'bad wolf'};const a=c.model;assert.equal(a.password,'bad wolf')}),it('normalizes user names',()=>{c.model={user:'rose',password:'bad wolf'};let a=c.model;assert.equal(a.user,'rose@local'),c.model={user:'doctor@tardis',password:'tenant'},a=c.model,assert.equal(a.user,'doctor@tardis')}),it('determines if credentials are available',()=>{let a=c.model;assert.equal(a.areAvailable,!1),c.model={macaroons:['macaroons']},a=c.model,assert.equal(a.areAvailable,!0)}),it('determines if creds are external',()=>{c.model={user:'doctor@tardis',password:'bad wolf'},c.externalAuth='foo';const a=c.model;assert.equal(a.areExternal,!0)})}),describe('macaroons',()=>{let b,c;beforeEach(()=>{b=a(),c=new window.jujugui.User({localStorage:b})}),it('can set a macaroon',()=>{c.setMacaroon('test','foo-bar'),assert.equal(b.getItem('test'),'foo-bar')}),it('can get a macaroon',()=>{b.setItem('test','foo-bar'),assert.equal(c.getMacaroon('test'),'foo-bar')}),it('can clear a macaroon',()=>{c.setMacaroon('test','foo-bar'),c.clearMacaroon('test'),assert.deepEqual(b.getItem('test'),null)})}),describe('identityURL',()=>{let b,c;beforeEach(()=>{b=a(),c=new window.jujugui.User({localStorage:b}),b.setItem('charmstore','<charmstore macaroon>'),b.setItem('identity','<identity token>'),b.setItem('terms','<terms macaroon>'),b.setItem('https://1.2.3.4/identity','<identity token>'),b.setItem('https://1.2.3.4/omni','<omni macaroon>'),b.setItem('https://1.2.3.4/null',null)}),it('returns the identity URL',()=>{assert.strictEqual(c.identityURL(),'https://1.2.3.4/identity')}),it('returns null if an URL with the identity token is not set',()=>{b.removeItem('https://1.2.3.4/identity'),assert.strictEqual(c.identityURL(),null)}),it('returns null if the token is not set',()=>{b.removeItem('identity'),assert.strictEqual(c.identityURL(),null)})}),describe('usernames',()=>{let b,c;beforeEach(()=>{b=a(),c=new window.jujugui.User({localStorage:b}),c.controller={user:'dalek'}}),it('uses the controller username',()=>{assert.equal(c.username,'dalek@local')}),it('can provide just the displayname',()=>{assert.equal(c.displayName,'dalek')}),it('defaults to externalAuth if available',()=>{c.externalAuth={user:{name:'foo'}},assert.equal(c.username,'foo'),assert.equal(c.displayName,'foo')})}),describe('expiration',()=>{let b,c;beforeEach(()=>{b=a(),c=new window.jujugui.User({sessionStorage:b})}),it('can set an expiration time',()=>{const a=new Date,d={sessionStorage:b,expirationDatetime:a};c=new window.jujugui.User(d),assert.deepEqual(new Date(c.expirationDatetime).getTime(),a.getTime())}),it('sets an expiration time in the future if one is not provided',()=>{assert.isAbove(new Date(c.expirationDatetime),new Date)}),it('does nothing prior to expiration time',()=>{b.setItem('foo','bar'),c._purgeIfExpired(),assert.equal(b.getItem('foo'),'bar')}),it('clears the storage when expiration time is reached',()=>{let a=new Date;a.setHours(a.getHours()-1);const d={sessionStorage:b,expirationDatetime:a};c=new window.jujugui.User(d),b.setItem('foo','bar'),c._purgeIfExpired(),assert.isNull(b.getItem('foo'))})})});